;;;ls.asm
;$Id: ls.Asm,v 1.8 2011/09/08 21:13:37 goosey Exp goosey $
;;;Print out the RAM directory
;;;with all its bits and bytes
;;;LS2 print flag bits as vamri rather than
;;;in binary


;;;print as "vamri XXXX FILNAM.EX"

;;;Willard Goosey
;;;goosey@sdc.org
;;;8/9/2011

include(`m100.def')
include(`8085undoc.def')
include(`z80mac.def')

	org 0f400h
main:
	call CLS	;in case we were called from BASIC
	;initialize lines in case we were called repeatedly 
	;from BASIC
	lxi h,lines	;HL-> lines
	mvi m,0		;lines=0

	lxi h,DIRECTORY ;HL-> ram dir

loop	mov a,m		;load first byte of dir entry
	cpi ENDDIR	;end of directory?
	jz done		;goto done if so
	cpi 80h		;valid?
	jm noent	;loop again if not
	inx h		;HL=HL+1
	shld dp		;dp=HL (dir pointer)

	;store status byte as VAMRI to buffer
	lxi h, buffer   ;HL-> buffer
	call vamri	;buffer = A decoded

	;advance HL past the 5 chars in buf
	ldhi(5)		;DE=HL+5
	xchg		;HL=DE

	;add a space to the buffer
	mvi m,' '	;*HL=' '
	inx h		;HL=HL+1
	shld bp		;bp=HL

	;store address in hex to buffer
	lhld dp		;HL->byte 2 of dir entry
	mov c,m		;C=*HL
	inx h		;HL++
	mov b,m		;b=*HL (BC=address of file)
	inx h		;HL=HL+1
	shld dp		;dp = HL
	lhld bp		;HL=bp
	call i2h	;HL->hex digits of BC

	;advance HL past the 4 hex digits
	ldhi(4)		;DE=HL+4
	xchg		;HL=DE 

	;add a space
	mvi m,' '	;*HL=space
	inx h		;HL=HL+1
	shld bp		;bp=HL

	;convert FILE  DO to FILE.DO and store to buffer
	lhld dp		;HL=dp

	;check for doubly-hidden easteregg filenames
	;m100 has 2, <null>suzuki and
	;<null>hayash.i
	;suzuki holds an unsaved basic program
	;hayash.i = paste buffer
	;
	mov a,m		;read first byte
	cpi 0		;null?
        jnz nothay      ;not null=not a doubly-hidden name
	inx h		;advance past the null

nothay	xchg		;DE=HL
	lhld bp		;HL=bp
	call MKPNAM     ;convert FILE  DO->
			;FILE.DO

	;print buffer
	lxi h,buffer    ;HL->buffer
	call LCDSTR     ;print from HL to null

	;pause for a keypress every 8 lines
	lda lines	;A=lines
	inr a		;A=A+1
	cpi 8		;compare to 8
	cz pause	;if A=8 then wait for key, a=0
	sta lines       ;lines=A and continue
	call CRLF	;print newline
	
	;advance to next dir entry
next    lhld dp		;HL=dp
	ldhi(8)		;DE=HL+8
	xchg		;HL=DE
	jmp loop	;do it again!    		


	;not a valid entry, point HL at next entry and loop
noent:  ldhi(11)	;DE=HL+11
	xchg		;HL=DE
	jmp loop	;again


done    call CHGET      ;wait for a keypress
	;fix power-off flag and return to menu or basic
	;fall thru to fixpower which returns

include(`fixpower.asm') 

pause   call CHGET	;wait for a key
	mvi a,0		;A=0
	ret

include(`vamri.asm')
include(`c2h.asm')

;data section

dp	dw 0
bp	dw 0
lines   db 0

buffer  dsz 20h
	end main
